<?php
namespace BwlFaqManager\Callbacks\AdminAjaxHandlers;

/**
 * Class TaxonomySortSaveCb
 *
 * @package BwlFaqManager
 */
class TaxonomySortSaveCb {


	public function save() {

		global $wpdb;

		$baf_sort_filter_type = sanitize_text_field( $_POST['baf_sort_filter_type'] );
		$baf_term_id          = sanitize_text_field( $_POST['baf_term_id'] );
		$baf_sort_data        = sanitize_text_field( $_POST['baf_sort_data'] );

		if ( $baf_sort_filter_type == 'category' ) {

			update_option( PREFIX_BAF_CAT . $baf_term_id, $baf_sort_data );
		} elseif ( $baf_sort_filter_type == 'topics' ) {

			$baf_topics_unique_option_id = 'baf_topics_' . $baf_term_id;
			update_option( $baf_topics_unique_option_id, $baf_sort_data );
		} elseif ( $baf_sort_filter_type == 'all' ) {

			// Save All Sorting Data (menu_order)

			$order   = explode( ',', $baf_sort_data );
			$counter = 0;

			foreach ( $order as $bwl_faq_id ) {

				$wpdb->update( $wpdb->posts, [ 'menu_order' => $counter ], [ 'ID' => $bwl_faq_id ] );
				++$counter;
			}
		} else {
			// Do nothing.
		}

		$post_data['status'] = 1;

		wp_reset_query();

		echo json_encode( $post_data );
		die();
	}
}
