<?php
namespace BwlFaqManager\Controllers\Shortcodes;

use Xenioushk\BwlPluginApi\Api\Shortcodes\ShortcodesApi;
use BwlFaqManager\Callbacks\Shortcodes\FaqAuthorCb;

/**
 * Class FaqAuthor
 *
 * @since: 1.1.1
 * @package BwlFaqManager
 */
class FaqAuthor {


	public $faqAuthorCb;
	public $shortcodesApi;

	public function __construct() {}
	public function register() {

		// Initialize API.
		$this->shortcodesApi = new ShortcodesApi();

		// Initialize callbacks.
		$this->faqAuthorCb = new FaqAuthorCb();

		$shortcodes = [
			[
				'tag'      => 'bwla_author', // FAQ Author Information
				'callback' => [ $this->faqAuthorCb, 'getFaqAuthor' ],
			],
		];

		$this->shortcodesApi->add_shortcodes( $shortcodes )->register();
	}
}
